import { defineStore } from 'pinia'
import { store } from '/@/store'

interface ControlState {
    allIP: string,
    allPort: string,
    resUrl: string,
    wsIP: string,
    wsPort: string,
    useSSL: string,
    relese: boolean,
}

export const useControlStore = defineStore({
    id: 'app-control',
    state: (): ControlState => ({
        // 控制台ip
        allIP: '',
        // 控制台端口号
        allPort: '',
        // res_url
        resUrl: '',
        // wsIp
        wsIP: '',
        // wsPort
        wsPort: '',
        // useSSL
        useSSL: '',
        // 是否relese
        relese: false,
    }),
    getters: {
        getAllIP(): string {
            return this.allIP
        },
        getAllPort(): string {
            return this.allPort
        },
        getResUrl(): string {
            return this.resUrl
        },
        getWsIP(): string {
            return this.wsIP
        },
        getWsPort(): string {
            return this.wsPort
        },
        getUseSSL(): string {
            return this.useSSL
        },
        getRelese(): boolean {
            return this.relese
        },

    },
    actions: {
        setAllIP(info) {
            this.allIP = info // for null or undefined value
        },
        setAllPort(roleList) {
            this.allPort = roleList
        },
        setResUrl(info) {
            this.resUrl = info
        },
        setWsIP(info) {
            this.wsIP = info
        },
        setWsPort(info) {
            this.wsPort = info
        },
        setUseSSL(info) {
            this.useSSL = info
        },
        setRelese(info) {
            this.relese = info
        },
    },
})

// Need to be used outside the setup
export function useUserStoreWithOut() {
    return useControlStore(store)
}
