/*
 * @Date: 2022-07-05 10:04:29
 * @LastEditors: 刘君
 * @LastEditTime: 2023-04-03 15:49:54
 * @FilePath: \plugins\rpc-topic\src\res_get.ts
 */
import axios, { Axios } from "axios";
import { useControlStore } from "/@/store/modules/control";
import { notification } from 'ant-design-vue'
axios.defaults.withCredentials = true
axios.defaults.headers.post['Content-Type'] = 'application/x-www-form-urlencoded'
export class GameClient {
    http: Axios
    user: string = '';
    password: string = '';
    constructor() {
        let baseURL = this.getUrl();
        this.http = new axios.Axios({ baseURL, responseType: 'json' });
        this.http.interceptors.response.use(res => {
            if (res.status != 200) {
                notification.error({ message: "获取数据出错!", description: res.data });
                return Promise.reject()
            }
            return res.data;
        });
    }
    setAuth(user, psw) {
        this.user = user;
        this.password = psw;
    }
    getUrl() {
        const store = useControlStore()
        let obj: any = store.getResUrl ? store.getResUrl : null;
        let baseURL = obj || 'http://127.0.0.1:80/'
        return baseURL
    }
    query(url: string, data?: Record<string, any>, config?: Record<string, any>) {
        this.http.defaults.baseURL = this.getUrl();
        // let grafanaUser = (window as any).grafanaBootData.user
        // let user = grafanaUser.login + '_' + grafanaUser.id + "_" + grafanaUser.email
        let _data = {
            user: this.user || '',
            password: this.password || '',
            add_http_cors_header: 1,
            max_result_rows: 1000,
            max_result_bytes: 10000000,
            default_format: 'JSONCompact',
            result_overflow_mode: 'break',
        }
        if (data) {
            Object.assign(_data, data)
        }
        return _data
    }
    post(url, data?) {
        let _data = this.query(url, data)
        return this.http.post(`${url}`, JSON.stringify(_data))
    }
    get(url, data?) {
        let _data = this.query(url, data);
        return this.http.get(`${url}`, { params: _data })
    }
}

export const resClient = new GameClient()