
import { HttpRequest, HttpResponse } from 'pi_pt/init/httprpc'
import { fromByteArray, toByteArray } from 'pi_utils/util/base64';
import { ab2hex, utf8Encode } from 'pi_utils/util/util';

// _req: HttpRequest, _resp: HttpResponse

let authInfo = {
    authState: false,
    auth: ""
};

export const checkHttpBasicAuth = (req: HttpRequest, _resp: HttpResponse) => {
    let auth = req.getHeader("authorization");
    // Basic dGVzdDoxMjM0NTY=
    console.log("auth:", auth);
    // 获取授权状态
    if (authInfo.authState && auth !== authInfo.auth) {
        throw new Error("check auth error");
    };
}


// 设置账号信息
export const setMgrUser = (user: string, pwd: string) => {
    // 生成授权信息 TODO
    let base64 = fromByteArray(utf8Encode(`${user}:${pwd}`));
    authInfo.authState = true;
    authInfo.auth = `Basic ${base64}`;
}