/**
 * 数据库管理
 */

import { Env } from "pi_utils/lang/env";
import { Log } from "pi_pt/util/log";
import { BonBuffer } from "pi_utils/serialization/bon";
import { Tr } from "pi_pt/db/mgr";
import { HttpRequest, HttpResponse } from 'pi_pt/init/httprpc'
import { Entrance } from "pi_utils/event/entrance.struct";
import { cfgMgr } from "pi_utils/util/cfg";
import { StructMgr } from "pi_utils/serialization/struct_mgr";
import { checkHttpBasicAuth } from "./auth_lib";
import { getCfgName } from "pi_pt/util/util";

declare var env: Env;
declare var structMgr: StructMgr;

/**
 * 获取所有rpc
 */
// #[httpRpc=/mgr/rpc/topic_list]
export const lists = async (req: HttpRequest, resp: HttpResponse) => {
    // 检测授权信息
    checkHttpBasicAuth(req, resp);
    
    //遍历入口配置， 将rpc的配置过滤出来
    let topics = [];
    await env.dbMgr.read(async (tr) => {
        for await (const data of tr.kvList("", getCfgName(Entrance._$info.name), null, false, "")) {
            topics.push(data[0]);
        }
    });

    return topics;
}

/**
 * 获取所有struct
 */
// #[httpRpc=/mgr/rpc/struct_list]
export const structList = async (req: HttpRequest, resp: HttpResponse) => {
    // 检测授权信息
    checkHttpBasicAuth(req, resp);

    if (!structs) {
        structs = [];
        structMgr.onRegister((meta) => {
            structs.push(meta.name);
        })
    }
    return structs;
}

let structs;

