import { Env } from "pi_utils/lang/env";
import { Log } from "pi_pt/util/log";
import { BonBuffer } from "pi_utils/serialization/bon";
import { checkAuth } from "./user.event";
import { DBType, Item, Tr } from "pi_utils/db/mgr";
import { HttpRequest, HttpResponse } from 'pi_pt/init/httprpc'
import { TabDecode, TabEncode } from "pi_utils/serialization/tab_meta";
import { TabMeta } from "pi_utils/serialization/sinfo";
import { WebShellMgr } from "pi_pt/native/pi_serv_lib/js_webshell";
import { PT_ENV } from "pi_pt/constant";
import { MqttConnection } from "pi_pt/native/pi_serv_lib/js_net";
import { publishEncodedMqttMessage } from "pi_pt/net/mqtt_broker";
import { checkHttpBasicAuth } from "./auth_lib";
import { to_pid } from "pi_pt/util/util";
import { get_pid_statistics } from "pi_pt/native/pi_serv_lib/js_lib";

declare var ESProcess;
declare var env: Env;


// 获取指定pid的堆栈信息
// #[httpRpc=/mgr/pid/get_stack]
export const get_pid_stack = async (req: HttpRequest, resp: HttpResponse) => {
    // 检测授权信息
    // checkHttpBasicAuth(req, resp);
    let data = req.getData();
    const vid = data.vid;
    const cid = data.cid;
    if (!vid) return "vid null";
    if (!cid) return "cid null";
    const pid = to_pid(Number(vid), Number(cid));
    let r = get_pid_statistics(pid);
    return JSON.stringify({ msg: r });
}